<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '../../common/meta';
import { NextStepAlt } from '../../components/common/index.vue';
import {
  Careers,
  Conduct,
  EventSection,
  EventsSchedule,
  FeaturedContent,
  FeaturedSpeaker,
  Intro,
  LightningHero,
  Party,
  SpeakerSession,
} from '../../components/events/index.vue';
import { KubeconLightingTalk } from '../../components/events/kubecon/index.vue';
import { FooterEditLinkMixin, LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';

export default Vue.extend({
  components: {
    LightningHero,
    Intro,
    EventSection,
    KubeconLightingTalk,
    EventsSchedule,
    SpeakerSession,
    Careers,
    Conduct,
    NextStepAlt,
    Party,
    FeaturedSpeaker,
    FeaturedContent,
  },
  nuxtI18n: false,
  mixins: [FooterEditLinkMixin, LivePreviewMixin],

  async asyncData({ $eventsService, params }: any) {
    try {
      const eventSlug = params.slug;
      const { items, content, spaceId, entryId } =
        await $eventsService.getChildEventContent(eventSlug);

      return { content, items, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {
      icons: [
        'bulb-bolt-96px',
        'code-96px',
        'celebrate-icon_celebrate-96px',
        'tee-96px',
      ],
      eventSlugs: {
        AWS_REINVENT: 'aws-reinvent',
        KUBECON: 'kubecon',
        RSA: 'rsa',
      },
    };
  },
  head() {
    return getPageMetadata((this as any).content.metadata, this.$route.path);
  },
  computed: {
    showFeaturedSpeaker() {
      return this.$route.params.slug === this.eventSlugs.RSA;
    },
    showKubeconLighting() {
      return this.$route.params.slug === this.eventSlugs.KUBECON;
    },
    showParty() {
      return this.$route.params.slug === this.eventSlugs.AWS_REINVENT;
    },
    showSessions() {
      return this.$route.params.slug !== this.eventSlugs.RSA;
    },
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.content =
            this.$eventsService.transformEventChildData(updatedData)),
      });

      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div>
    <LightningHero v-if="content.hero" :data="content.hero" :icons="icons" />

    <Intro v-if="content.description" :data="content.description" />

    <div v-if="content.booth">
      <EventSection
        v-for="(item, index) in content.booth"
        :key="item.header"
        :reverse="index % 2 !== 0"
        class="slp-pb-32"
        :data="item"
      />
    </div>

    <!-- RSA SPEAKER SECTION -->
    <div v-if="content.sessions && showFeaturedSpeaker">
      <FeaturedSpeaker
        v-for="(session, sessionIndex) in content.sessions"
        :key="sessionIndex"
        :data="session"
      />
    </div>

    <div v-if="content.featuredContent">
      <template v-if="showKubeconLighting">
        <KubeconLightingTalk
          v-for="feature in content.featuredContent"
          :key="feature.header"
          :data="feature"
        />
      </template>
      <template v-else>
        <FeaturedContent
          v-if="content.featuredContent"
          :data="content.featuredContent"
        />
      </template>
    </div>

    <div v-if="content.social">
      <template v-if="showParty">
        <party v-for="item in content.social" :key="item.header" :data="item" />
      </template>
      <template v-else>
        <EventSection
          v-for="socialEvent in content.social"
          :key="socialEvent.header"
          :has-gradient="$route.params.slug !== eventSlugs.RSA"
          :icon="'celebrate-24px'"
          class="slp-py-160"
          :data="socialEvent"
        />
      </template>
    </div>

    <div v-if="content.sessions && showSessions">
      <SpeakerSession
        v-for="(session, sessionIndex) in content.sessions"
        :key="sessionIndex"
        :data="session"
      />
    </div>

    <EventsSchedule v-if="content.agenda" :data="content.agenda" />

    <Careers v-if="content.careers" :data="content.careers" />

    <div v-if="content.footnote">
      <Conduct
        v-for="footnote in content.footnote"
        :key="footnote.header"
        :data="footnote"
      />
    </div>

    <NextStepAlt />
  </div>
</template>
